#!/usr/bin/php
<?php
include dirname(__FILE__)."/functions.php";
global $oids, $snmp_details;

//CISCO-CLASS-BASED-QOS-MIB::
$oids = array (
		'ifIndex'	=>	'.1.3.6.1.4.1.9.9.166.1.15.1.1.10',	//cbQosCMPostPolicyByte64
		'cfgIndex'	=>	'.1.3.6.1.4.1.9.9.166.1.5.1.1.2',	//cbQosConfigIndex
		'parent'	=>	'.1.3.6.1.4.1.9.9.166.1.5.1.1.4',	//cbQosParentObjectsIndex
		'ifmibifind'	=>	'.1.3.6.1.4.1.9.9.166.1.1.1.1.4',	//cbQosServicePolicy.cbQosIfIndex
		'ifAlias'	=>	'.1.3.6.1.2.1.31.1.1.1.18',		//IF-MIB::ifAlias
		'ifDescr'	=>	'.1.3.6.1.2.1.2.2.1.2',			//IF-MIB::ifDescr
		'ifOperStatus'	=>	'.1.3.6.1.2.1.2.2.1.8',			//IF-MIB::ifOperStatus
		'ifName'	=>	'.1.3.6.1.2.1.31.1.1.1.1',		//IF-MIB::ifName
		'class'		=>	'.1.3.6.1.4.1.9.9.166.1.7.1.1.1',	//cbQosCMName
		'policy'	=>	'.1.3.6.1.4.1.9.9.166.1.6.1.1.1',	//cbQosPolicyMapName
		'direction'	=>	'.1.3.6.1.4.1.9.9.166.1.1.1.1.3',	//cbQosPolicyDirection
		'cfgRate'	=>	'.1.3.6.1.4.1.9.9.166.1.12.1.1.1',	//cbQosPoliceCfgRate
		'conformedByte'	=>	'.1.3.6.1.4.1.9.9.166.1.17.1.1.6',	//cbQosPoliceConformedByte64
		'exceededByte'	=>	'.1.3.6.1.4.1.9.9.166.1.17.1.1.13',	//cbQosPoliceExceededByte64
		'postPolicyByte'=>	'.1.3.6.1.4.1.9.9.166.1.15.1.1.10'	//cbQosCMPostPolicyByte64
		);

$auth=explode("::",$_SERVER['argv'][2]);

$snmp_details['hostname']=$_SERVER['argv'][1];
$snmp_details['community']=$auth[1];
$snmp_details['version']=$auth[0];
$snmp_details['username']=$auth[2];
$snmp_details['password']=$auth[3];
$snmp_details['auth_proto']=$auth[4];
$snmp_details['priv_pass']=$auth[5];
$snmp_details['priv_proto']=$auth[6];
$snmp_details['context']=$auth[7];
$oid=(isset($_SERVER['argv'][5])) ? $_SERVER['argv'][5] : false;

$task=$_SERVER['argv'][3];
$target=(isset($_SERVER['argv'][4]) ? $_SERVER['argv'][4] : false);
 
if ($task=='query' || $task=='index') {
    if ($task=='index') $target='index';
    
    $ifInd=response("ifIndex");
    foreach ($ifInd as $ifIndexOid => $ifIndexVal) {
	$Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	$ifIndexes[$ifIndexOid]=$Index;
    }
    
    switch ($target) {
    case "index":
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    if ($task=='query') 
		echo $ifIndexVal."::".$ifIndexVal."\n";
	    else
		echo $ifIndexVal."\n";
	}
	break;
    case "status":
	$ifmibifindexes=response("ifmibifind");
	$statuses=response("ifOperStatus");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	    $Index=substr($Index,0,strpos($Index,"."));
	    echo $ifIndexVal."::".($statuses[ $oids["ifOperStatus"].".".$ifmibifindexes[$oids["ifmibifind"].".$Index"] ]==1 ? "<font color=blue>Up</font>" : "<font color=red>Down</font>")."\n";
	}
	break;
    case "descr":
	$ifmibifindexes=response("ifmibifind");
	$descrs=response("ifDescr");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	    $Index=substr($Index,0,strpos($Index,"."));
	    echo $ifIndexVal."::".$descrs[ $oids["ifDescr"].".".$ifmibifindexes[$oids["ifmibifind"].".$Index"]]."\n";
	}
	break;
    case "name":
	$ifmibifindexes=response("ifmibifind");
	$names=response("ifName");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	    $Index=substr($Index,0,strpos($Index,"."));
	    echo $ifIndexVal."::".$names[ $oids["ifName"].".".$ifmibifindexes[$oids["ifmibifind"].".$Index"]]."\n";
	}
	break;
    case "alias":
	$ifmibifindexes=response("ifmibifind");
	$aliases=response("ifAlias");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	    $Index=substr($Index,0,strpos($Index,"."));
	    echo $ifIndexVal."::".$aliases[ $oids["ifAlias"].".".$ifmibifindexes[$oids["ifmibifind"].".$Index"]]."\n";
	}
	break;
    case "class":
	$cfgIndexes=response("cfgIndex");
	$classes=response("class");

	foreach ($cfgIndexes as $cfgIndexOid => $cfgIndexVal) {
	    $Index = str_replace($oids["cfgIndex"].".","",$cfgIndexOid);
	    if (isset($classes[$oids["class"].".$cfgIndexVal"]) && isset($ifIndexes[$oids["ifIndex"].".$Index"]))
		echo $Index."::".$classes[$oids["class"].".$cfgIndexVal"]."\n";
	}
	break;
    case "policy":
	$cfgIndexes=response("cfgIndex");
	$policies=response("policy");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	    $Index=substr($Index,0,strpos($Index,"."));
	    echo $ifIndexVal."::".$policies[$oids["policy"].".".$cfgIndexes[$oids["cfgIndex"].".$Index.$Index"]]."\n";
	}
	break;
    case "direction":
	$directions=response("direction");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	    $Index=substr($Index,0,strpos($Index,"."));
	    if (isset($directions[$oids["direction"].".$Index"]))
		echo $ifIndexVal."::".($directions[$oids["direction"].".$Index"]==1 ? "&nbsp;&darr;input" : "&nbsp;&uarr;output")."\n";
	}
	break;
    case "cfgrate":
	$cfgIndexes=response("cfgIndex");
	$cfgIndexesI = array_flip($cfgIndexes);
	$cfgRates=response("cfgRate");

	$parents=response("parent");

	foreach ($cfgRates as $cfgRateOid => $cfgRateVal) {
	    $cfgRateInd = str_replace($oids["cfgRate"].".","",$cfgRateOid);
	    $cfgInd=str_replace($oids["cfgIndex"].".","",$cfgIndexesI[$cfgRateInd]);
	    $indClass = substr($cfgInd,0,strpos($cfgInd,"."));
	    $parentInd = $indClass.".".$parents[$oids["parent"].".".$cfgInd];
	    $cfgRatesNew[$parentInd]=$cfgRateVal;
	}

	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	    echo $ifIndexVal."::".(isset($cfgRatesNew[$Index]) ? $cfgRatesNew[$Index] : 0)."\n";
	}
	break;
    default:
	die("klaidingas parametras\n");
    }
} elseif ($task=='get' && $target=='postPolicyByte') {
    $result = @snmp_data($oids[$target].".$oid");
    echo (intval($result)==0) ? 0 : $result;
} elseif ( $task=='get' && ( $target=='exceededByte' || $target=='conformedByte') ) {
    $indClass = substr($oid,0,strpos($oid,"."));
    $indPolicy = str_replace($indClass.".","",$oid);
    $oids["parent"].=".$indClass";
    $query=response("parent");
    $result=0;
    foreach ($query as $subQueryId => $subQueryVal) {
	if ($subQueryVal==$indPolicy) {
	    $childId=str_replace($oids["parent"].".","",$subQueryId);
	    $result += @snmp_data($oids[$target].".$indClass.$childId");
	}
    }
    echo (intval($result)==0) ? 0 : $result;
} else {
    die("nepakanka parametru\n");
}

function response($task) {
    global $snmp_details,$oids;
    $results=false;

    $query = snmp_data_array($oids[$task]);

    foreach ($query as $ind => $q) {
	$results[".".$q['oid']]=$q['value'];
    }
    return $results;
}

?>